opscp 3.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131
  1. #!/bin/bash
  2. # vim: expandtab:tabstop=4:shiftwidth=4
  3. function usage() {
  4. cat << EOF
  5. Usage: opscp [OPTIONS] local remote
  6. Options:
  7. --version show program's version number and exit
  8. --help show this help message and exit
  9. -l USER, --user=USER username (OPTIONAL)
  10. -p PAR, --par=PAR max number of parallel threads (OPTIONAL)
  11. --outdir=OUTDIR output directory for stdout files (OPTIONAL)
  12. --errdir=ERRDIR output directory for stderr files (OPTIONAL)
  13. -e ENV, --env ENV which environment to use
  14. -t HOST_TYPE, --host-type HOST_TYPE
  15. which host type to use
  16. --list-host-types list all of the host types
  17. --timeout=TIMEOUT timeout (secs) (0 = no timeout) per host (OPTIONAL)
  18. -O OPTION, --option=OPTION
  19. SSH option (OPTIONAL)
  20. -v, --verbose turn on warning and diagnostic messages (OPTIONAL)
  21. -A, --askpass Ask for a password (OPTIONAL)
  22. -x ARGS, --extra-args=ARGS
  23. Extra command-line arguments, with processing for
  24. spaces, quotes, and backslashes
  25. -X ARG, --extra-arg=ARG
  26. Extra command-line argument
  27. -r, --recursive recusively copy directories (OPTIONAL)
  28. Example: opscp -t ex-srv -e stg -l irb2 foo.txt /home/irb2/foo.txt
  29. EOF
  30. }
  31. if [ $# -eq 0 ] || [ "$1" == "--help" ]
  32. then
  33. usage
  34. exit 1
  35. fi
  36. # See if ohi is installed
  37. if ! which ohi &>/dev/null ; then
  38. echo "ERROR: can't find ohi (OpenShift Host Inventory) on your system, please either install the openshift-ansible-bin package, or add openshift-ansible/bin to your path."
  39. exit 10
  40. fi
  41. PAR=200
  42. USER=root
  43. TIMEOUT=0
  44. ENV=""
  45. HOST_TYPE=""
  46. while [ $# -gt 0 ] ; do
  47. case $1 in
  48. -t|--host-type)
  49. shift # get past the option
  50. HOST_TYPE=$1
  51. shift # get past the value of the option
  52. ;;
  53. -e)
  54. shift # get past the option
  55. ENV=$1
  56. shift # get past the value of the option
  57. ;;
  58. --timeout)
  59. shift # get past the option
  60. TIMEOUT=$1
  61. shift # get past the value of the option
  62. ;;
  63. -p|--par)
  64. shift # get past the option
  65. PAR=$1
  66. shift # get past the value of the option
  67. ;;
  68. -l|--user)
  69. shift # get past the option
  70. USER=$1
  71. shift # get past the value of the option
  72. ;;
  73. --list-host-types)
  74. ohi --list-host-types
  75. exit 0
  76. ;;
  77. -h|--hosts|-H|--host|-o)
  78. echo "ERROR: unknown option $1"
  79. exit 20
  80. ;;
  81. *)
  82. args+=("$1")
  83. shift
  84. ;;
  85. esac
  86. done
  87. # Get host list from ohi
  88. if [ -n "$ENV" -a -n "$HOST_TYPE" ] ; then
  89. HOSTS="$(ohi -t "$HOST_TYPE" -e "$ENV" 2>/dev/null)"
  90. OHI_ECODE=$?
  91. elif [ -n "$ENV" ] ; then
  92. HOSTS="$(ohi -e "$ENV" 2>/dev/null)"
  93. OHI_ECODE=$?
  94. elif [ -n "$HOST_TYPE" ] ; then
  95. HOSTS="$(ohi -t "$HOST_TYPE" 2>/dev/null)"
  96. OHI_ECODE=$?
  97. else
  98. echo
  99. echo "Error: either -e or -t must be specified"
  100. echo
  101. exit 10
  102. fi
  103. if [ $OHI_ECODE -ne 0 ] ; then
  104. echo
  105. echo "ERROR: ohi failed with exit code $OHI_ECODE"
  106. echo
  107. echo "This is usually caused by a bad value passed for host-type or environment."
  108. echo
  109. exit 25
  110. fi
  111. exec pscp.pssh -t $TIMEOUT -p $PAR -l $USER -h <(echo "$HOSTS") "${args[@]}"